import junit.framework.*;
import junit.framework.Assert;

/** JUnit test class for Complex class
 * 
 * @author $Author: u9207147 $
 * @version $Revision: 21 $
 * $Date: 2006-03-27 15:52:12 +1100 (Mon, 27 Mar 2006) $
 * 
 * */

public class TestComplex extends TestCase {
 
 // complex numbers for testing
 private Complex a, c, c1, c2, r, i;
 
 // don't need it for JUnit3.8 and later? (won't hurt...)
 public TestComplex(String name) {
  super(name);
 }

 // Set up for complex test 
 public void setUp() {
  a  = new Complex(1, 1);
  c1 = new Complex(1, 2);
  c2 = new Complex(-2, 7);
  c  = new Complex(-1, 9);
  r  = new Complex(3, 0);
  i  = new Complex(0, 3);
 }
 public void testComplex() {
  assertNotNull("No complex number exists.", c1);
 }

 public void testAddition() {
  assertEquals(c, c1.add(c2));
  assertEquals("Commutativity broken.",c1.add(c2), c2.add(c1));
 }

 public void testSubtraction() {
  assertEquals(new Complex(-3, 5), c2.subtract(c1));
  assertEquals(new Complex(0, 0), c.subtract(c));
 }

 public void testConjugate() {
  assertEquals(c, (c.conjugate()).conjugate());
  assertTrue(c1.arg() ==  -(c1.conjugate()).arg());
  assertTrue(c.arg() == (new Complex(c.getReal() * 10, 
      c.getImag() * 10)).arg());
 }

 public void testAbs() {
  assertTrue(c.abs() == (c.conjugate()).abs());
  assertTrue(i.abs() == r.abs());
  assertTrue(c.subtract(c).abs() == 0);
 }

 public void testArg() {
  assertTrue(a.arg() == 0.25 * Math.PI);
  assertTrue(r.arg() == 0.0);
  assertTrue(i.arg() == 0.5 * Math.PI);
 }
 
 public void testMultiplication() {
  assertEquals(c1.multiply(c2), c2.multiply(c1));
  assertTrue(r.multiply(i).getReal() != 0 ||
        i.multiply(r).getImag() != 0);
 }
}
